diff -rupN /usr/src/linux-2.4.9/Documentation/Configure.help linux/Documentation/Configure.help
--- /usr/src/linux-2.4.9/Documentation/Configure.help	Fri Aug 24 00:12:45 2001
+++ linux/Documentation/Configure.help	Sun Aug 26 00:01:15 2001
@@ -2494,6 +2494,13 @@ CONFIG_PCMCIA_SERIAL_CS
   a module, say M here and read Documentation/modules.txt. If unsure,
   say N.
 
+Asynchronous I/O support
+CONFIG_AIO
+  Enables support for Posix Asynchronous I/O Facilities. AIO is supported
+  on all filesystems, including those that have enabled Raw I/O
+  (see "Support raw access to SCSI disk devices" under
+  "SCSI support").
+
 /dev/agpgart (AGP Support) (EXPERIMENTAL)
 CONFIG_AGP
   AGP (Accelerated Graphics Port) is a bus system mainly used to
@@ -11724,6 +11731,12 @@ CONFIG_REISERFS_CHECK
   effect on end users.  If you are on the verge of sending in a bug
   report, say yes and you might get a useful error message.  Almost
   everyone should say no.
+
+CONFIG_REISERFS_RAW
+  Setting this to yes will enable a set of ioctls that provide raw
+  interface to reiserfs tree, bypassing directories, and automatically
+  removing aged files.  This is an experimental feature disigned for
+  squid cache directories. See Documentation/filesystems/reiserfs_raw.txt
 
 Second extended fs support
 CONFIG_EXT2_FS
diff -rupN /usr/src/linux-2.4.9/arch/i386/config.in linux/arch/i386/config.in
--- /usr/src/linux-2.4.9/arch/i386/config.in	Sat Jul 21 20:20:34 2001
+++ linux/arch/i386/config.in	Sat Aug 25 01:18:48 2001
@@ -185,6 +185,11 @@ endmenu
 mainmenu_option next_comment
 comment 'General setup'
 
+bool 'Asynchronous I/O support' CONFIG_AIO
+if [ "$CONFIG_AIO" = "y" ]; then
+	int  'System-wide limit on outstanding I/Os' CONFIG_AIO_MAX 4096
+fi
+
 bool 'Networking support' CONFIG_NET
 bool 'SGI Visual Workstation support' CONFIG_VISWS
 if [ "$CONFIG_VISWS" = "y" ]; then
diff -rupN /usr/src/linux-2.4.9/arch/i386/kernel/entry.S linux/arch/i386/kernel/entry.S
--- /usr/src/linux-2.4.9/arch/i386/kernel/entry.S	Sat Jul 21 20:19:26 2001
+++ linux/arch/i386/kernel/entry.S	Sat Aug 25 01:18:48 2001
@@ -620,6 +620,39 @@ ENTRY(sys_call_table)
 	.long SYMBOL_NAME(sys_getdents64)	/* 220 */
 	.long SYMBOL_NAME(sys_fcntl64)
 	.long SYMBOL_NAME(sys_ni_syscall)	/* reserved for TUX */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 225 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 230 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 235 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 240 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 245 */
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)
+	.long SYMBOL_NAME(sys_ni_syscall)	/* 250 */
+#if defined(CONFIG_AIO)
+	.long SYMBOL_NAME(sys_aio)		/* 251 */
+#else
+	.long SYMBOL_NAME(sys_ni_syscall)
+#endif
 
 	/*
 	 * NOTE!! This doesn't have to be exact - we just have
diff -rupN /usr/src/linux-2.4.9/drivers/scsi/sd.c linux/drivers/scsi/sd.c
--- /usr/src/linux-2.4.9/drivers/scsi/sd.c	Sat Aug 11 15:52:42 2001
+++ linux/drivers/scsi/sd.c	Sat Aug 25 01:18:48 2001
@@ -42,6 +42,9 @@
 #include <linux/errno.h>
 #include <linux/interrupt.h>
 #include <linux/init.h>
+#if defined(CONFIG_RAW) && defined(CONFIG_AIO)
+#include <linux/aio.h>
+#endif
 
 #include <linux/smp.h>
 
@@ -661,6 +664,31 @@ static void rw_intr(Scsi_Cmnd * SCpnt)
 	 */
 	scsi_io_completion(SCpnt, good_sectors, block_sectors);
 }
+
+#if defined(CONFIG_RAW) && defined(CONFIG_AIO)
+/*
+ * XXX Interfaces for AIO; ideally done through fops.
+ */
+int
+kaio_is_raw(struct file *filp)
+{
+	return(filp->f_op == &sd_raw_fops);
+}
+
+int
+kaio_raw_wait(void *handle, struct kiobuf *kb)
+{
+	return(sd_raw_wait(handle, kb));
+}
+
+void *
+kaio_raw_rw(int rw, struct file *filp, char *buf, size_t count, loff_t *ppos, 
+	  int *error, struct semaphore *semp, struct kiobuf *iobufp)
+{
+	return(sd_raw_rw(rw, filp, buf, count, ppos, error, semp, iobufp));
+}
+#endif	/* CONFIG_AIO */
+
 /*
  * requeue_sd_request() is the request handler function for the sd driver.
  * Its function in life is to take block device requests, and translate
diff -rupN /usr/src/linux-2.4.9/fs/Config.in linux/fs/Config.in
--- /usr/src/linux-2.4.9/fs/Config.in	Sat Jul 21 20:19:58 2001
+++ linux/fs/Config.in	Sat Aug 25 17:16:00 2001
@@ -10,6 +10,7 @@ tristate 'Kernel automounter version 4 s
 
 dep_tristate 'Reiserfs support' CONFIG_REISERFS_FS $CONFIG_EXPERIMENTAL
 dep_mbool '  Have reiserfs do extra internal checking' CONFIG_REISERFS_CHECK $CONFIG_REISERFS_FS $CONFIG_EXPERIMENTAL
+dep_mbool '  Enable reiserfs_raw interface' CONFIG_REISERFS_RAW $CONFIG_REISERFS_FS $CONFIG_EXPERIMENTAL
 
 dep_tristate 'ADFS file system support' CONFIG_ADFS_FS $CONFIG_EXPERIMENTAL
 dep_mbool '  ADFS write support (DANGEROUS)' CONFIG_ADFS_FS_RW $CONFIG_ADFS_FS $CONFIG_EXPERIMENTAL
diff -rupN /usr/src/linux-2.4.9/fs/read_write.c linux/fs/read_write.c
--- /usr/src/linux-2.4.9/fs/read_write.c	Sat Aug 11 15:52:46 2001
+++ linux/fs/read_write.c	Sat Aug 25 22:13:25 2001
@@ -2,6 +2,12 @@
  *  linux/fs/read_write.c
  *
  *  Copyright (C) 1991, 1992  Linus Torvalds
+ *
+ * KAIO modifications:
+ * 	Copyright 1999, Silicon Graphics, Inc.
+ *
+ * 	Written October 1999 by Rajagopal Ananthanarayanan (ananth)
+ *                      at Silicon Graphics, Inc.
  */
 
 #include <linux/slab.h> 
@@ -13,6 +19,9 @@
 #include <linux/dnotify.h>
 
 #include <asm/uaccess.h>
+#if defined(CONFIG_AIO)
+#include <linux/aio.h>
+#endif
 
 struct file_operations generic_ro_fops = {
 	llseek:		generic_file_llseek,
@@ -406,3 +415,92 @@ out:
 bad_file:
 	return ret;
 }
+
+#if defined(CONFIG_AIO)
+
+#ifdef DEBUG
+#define dprintk(x) printk x
+#else
+#define dprintk(x)
+#endif
+
+asmlinkage int sys_aio(int cmd,
+			unsigned long arg1,
+			unsigned long arg2,
+			unsigned long arg3,
+			unsigned long arg4)
+{
+	int ret = 0;
+
+
+	if (!current->kaio_info) {
+		lock_kernel();
+		if (!current->kaio_info && cmd != AIOCMD_SLAVE) {
+			kaio_q_create(current);
+			unlock_kernel();
+			return -ENOTCONN;
+		}
+		unlock_kernel();
+	}
+
+	switch (cmd) {
+	case AIOCMD_READ:
+	case AIOCMD_WRITE:
+	{
+		return(kaio_rw(cmd, (aiocb_t *)arg1, 0));
+	}
+        case AIOCMD_IOCTL:
+        case AIOCMD_CLOSE:
+        {
+                return(kaio_syscall(cmd, (aiocb_t *)arg1));
+        }
+	case AIOCMD_SUSPEND:
+	{
+		/* aio_suspend(aiocb_t *list[], nent, timeout) */
+		return (kaio_suspend((aiocb_t **)arg1, arg2,
+				(struct timespec *)arg3, 1));
+	}
+	case AIOCMD_CANCEL:
+	{
+		/* aio_cancel(int fd, aiocb_t *aiocb); */
+		kaio_key_t kkey;
+
+		if (arg2 && copy_from_user(&kkey, &((aiocb_t *)arg2)->aio_key, sizeof(kaio_key_t))) {
+			ret = -EFAULT;
+			break;
+		}
+		return(kaio_cancel((int)arg1, arg2 ?  &kkey : 0));
+	}
+	case AIOCMD_LIST_IO:
+	{
+		/*
+		 * lio_listio(int mode, aiocb_t *const list[],
+		 * 		int nent, sigevent_t *sig);
+		 */
+		return (kaio_list_io((int)arg1, (struct aiocb **)arg2,
+				   (int)arg3, (sigevent_t *)arg4));
+	}
+	case AIOCMD_PCINVALIDATE:
+	{
+		struct file * file;
+
+		if (!(file = fget(arg1))) {
+			ret = -EINVAL;
+			break;
+		}
+		lock_kernel();
+		truncate_inode_pages(file->f_dentry->d_inode->i_mapping, 0);
+		fput(file);
+		break;
+	}
+	case AIOCMD_SLAVE:
+		lock_kernel();
+		kaio_slave();
+		return 0;
+	default:
+		ret = -EINVAL;
+	}
+	unlock_kernel();
+	return ret;
+}
+#endif /* CONFIG_AIO */
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/Makefile linux/fs/reiserfs/Makefile
--- /usr/src/linux-2.4.9/fs/reiserfs/Makefile	Mon Jan 15 22:42:32 2001
+++ linux/fs/reiserfs/Makefile	Sat Aug 25 17:18:11 2001
@@ -11,6 +11,10 @@ O_TARGET := reiserfs.o
 obj-y   := bitmap.o do_balan.o namei.o inode.o file.o dir.o fix_node.o super.o prints.o objectid.o \
 lbalance.o ibalance.o stree.o hashes.o buffer2.o tail_conversion.o journal.o resize.o tail_conversion.o version.o item_ops.o ioctl.o
 
+ifdef CONFIG_REISERFS_RAW
+obj-y += raw.o pgc.o age_class.o
+endif
+
 obj-m   := $(O_TARGET)
 
 include $(TOPDIR)/Rules.make
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/age_class.c linux/fs/reiserfs/age_class.c
--- /usr/src/linux-2.4.9/fs/reiserfs/age_class.c	Thu Jan  1 03:00:00 1970
+++ linux/fs/reiserfs/age_class.c	Sat Aug 25 17:18:36 2001
@@ -0,0 +1,211 @@
+/*
+ * fs/reiserfs/age_class.c
+ *
+ * Class LRU routines for file aging and replacement.
+ *
+ * Written by Yury Shevchuk <sizif@botik.ru>
+ *
+ * Changes:
+ *      20000826 Linear interpolation for threshold calculation
+ *      proposed by Nikita Danilov <nikitadanilov@yahoo.com>
+ *
+ * Copyright 2000 Hans Reiser, see reiserfs/README for licensing and copyright details
+ *
+ * $Id: age_class.c,v 1.1.2.6 2000/09/08 14:42:45 sizif Exp $
+ */
+
+#include <linux/age_class.h>
+
+#define DUMMY(ARGS...)
+#define debug(N,M)	DUMMY
+
+#ifdef __KERNEL__
+#  include <linux/sched.h>
+#  include <linux/reiserfs_fs.h>
+#  include <linux/smp_lock.h>
+#  define assert(X)	BUG();
+#  define snprintf(STR, N, FMT, ARGS...)  sprintf (STR, FMT, ## ARGS)
+#  define SAFETY_MARGIN 100
+#else
+#  define SAFETY_MARGIN 0	/* not needed if snprintf is available */
+#endif
+
+
+void
+age_class_init (age_class *a, time_t curtime)
+{
+    int i = AGE_CLASS_COUNT;
+    while (--i >= 0) {
+	a->class[i].c = 0;
+	a->class[i].t = curtime;
+    }
+    a->total = 0;
+}
+
+
+/* count object with timestamp TIME in appropriate class (INC=1 for
+   arrival, INC=-1 for departure) */
+
+void
+age_class_update (age_class *a, time_t time, int inc)
+{
+    int n = age_class_find (a, time);
+    unsigned old = a->class[n].c;
+    unsigned new = a->class[n].c + inc;
+
+    if ((old^new) & 0x80000000) {
+	/* Counter overflow can occur if you have too many (>> 4G)
+	   objects -- use 64 bit counters then, while underflow means
+	   an error somewhere (missing positive update) */
+	debug(86, 1)
+	  ("age_class_update: class[%u].c = %u + (%d) would overflow, refusing\n",
+	   n, old, inc);
+	return;
+    }
+
+    a->class[n].c = new;
+    a->total += inc;
+}
+
+
+/* find age class where timestamp TIME currently belongs */
+
+int
+age_class_find (age_class *a, time_t time)
+{
+    int i;
+    for (i = 0; i < AGE_CLASS_COUNT; i++) {
+	if (time >= a->class[i].t)
+	    return i;
+    }
+    assert (0);
+    return 0;
+}
+
+
+/* The periodical shift procedure.  Returns 0 if shift isn't done
+   because class0 isn't big enough */
+
+int
+age_class_shift (age_class *a, time_t curtime)
+{
+    unsigned long min;
+    int i, chosen;
+
+    /* Don't shift unless class[0].c is big enough, and time interval
+       is wider than zero. */
+    if (a->class[0].c <= a->total/AGE_CLASS_COUNT
+	|| a->class[0].t >= curtime)
+	return 0;
+
+    /* Consider all neighbouring class pairs to find the pair to
+       merge.  We will merge the pair for which the sum of the
+       counters is minimal. */
+
+    min = ULONG_MAX;
+    chosen = 1;
+
+    for (i = 1; i < AGE_CLASS_COUNT; i++) {
+	int sum = a->class[i-1].c + a->class[i].c;
+	if (sum < min) {
+	    min = sum;
+	    chosen = i;
+	}
+    }
+
+    debug(86, 5) ("age_class_shift: shift up to class[%u]\n", chosen);
+
+    i = chosen-1;
+    a->class[i+1].c += a->class[i].c;
+    a->class[i].t = a->class[i-1].t;
+    while (--i > 0) {
+        a->class[i+1].c = a->class[i].c;
+	a->class[i].t = a->class[i-1].t;
+    }
+    a->class[1].c = a->class[0].c;
+    a->class[0].c = 0;
+    a->class[0].t = curtime;
+
+    return 1;
+}
+
+
+/* dump age_class for debugging purposes */
+
+char *
+age_class_dump (age_class *a, time_t curtime, char *buf, int bufsz)
+{
+    char *p = buf;
+    int room_left = bufsz - SAFETY_MARGIN;
+    time_t t = curtime;
+    int i;
+
+    for (i = 0; i < AGE_CLASS_COUNT; i++) {
+	int n = snprintf (p, room_left, 
+			  "  class %02d: files %-12u span %10ld..%-10ld = %-10ld\n",
+			  i, a->class[i].c, a->class[i].t+1, t, t-a->class[i].t);
+	p += n;
+	if ((room_left -= n) <= 0)
+	    break;
+	t = a->class[i].t;
+    }
+    if (room_left > 0) {
+	int n = snprintf (p, room_left, 
+			  "  total     files %-12u\n", a->total);
+	p += n;
+	room_left -= n;
+    }
+    return buf;
+}
+
+
+/* Compute age threshold based on desired file ratio.  The ratio is
+   defined as M/N*100 where M is the count of files above threshold, N
+   is the total number of files.  For example, for ratio=20 threshold
+   will be chosen so that every 5th file will be above the threshold. */
+
+time_t
+age_class_threshold (age_class *a, unsigned ratio, time_t curtime)
+{
+    unsigned long aged = 0;
+    unsigned long r1, r2 = 0;
+    time_t t1, t2;
+    int i = AGE_CLASS_COUNT;
+
+    /* We should never be called if there are no files,
+       but let's play safe */
+    if (! a->total)
+	return 0;
+
+    t1 = t2 = r1 = 0;   /* only to avoid incorrect warning */
+
+    while (--i > 0) {
+	aged += a->class[i].c;
+	if (aged == 0)
+	    continue;
+	r1 = r2;
+	r2 = aged*100/a->total;
+	if (r2 >= ratio) {
+	    t1 = a->class[i].t;
+	    t2 = a->class[i-1].t;
+	    break;
+	}
+    }
+
+    if (i == 0) {
+	r1 = r2;
+	r2 = 100;
+	t1 = a->class[0].t;
+	t2 = curtime;
+    }
+
+    /* Now the threshold is within class i, r1 <= ratio <= r2, (r1 != r2),
+       t1 <= age_threshold <= t2.  Interpolate to find the threshold  */
+
+    return t1 + (t2-t1)*(ratio - r1)/(r2-r1);
+}
+
+/*
+  ;;; Local Variables: ***
+  ;;; tab-width:8 ***
+*/
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/dir.c linux/fs/reiserfs/dir.c
--- /usr/src/linux-2.4.9/fs/reiserfs/dir.c	Sat Jul 21 20:20:56 2001
+++ linux/fs/reiserfs/dir.c	Sat Aug 25 17:48:44 2001
@@ -28,6 +28,7 @@ struct file_operations reiserfs_dir_oper
     read:	generic_read_dir,
     readdir:	reiserfs_readdir,
     fsync:	reiserfs_dir_fsync,
+    ioctl:      reiserfs_dir_ioctl,
 };
 
 /*
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/inode.c linux/fs/reiserfs/inode.c
--- /usr/src/linux-2.4.9/fs/reiserfs/inode.c	Sat Jul 21 20:20:56 2001
+++ linux/fs/reiserfs/inode.c	Sun Aug 26 02:44:30 2001
@@ -58,7 +58,7 @@ void reiserfs_delete_inode (struct inode
     unlock_kernel() ;
 }
 
-static void _make_cpu_key (struct cpu_key * key, int version, __u32 dirid, __u32 objectid, 
+void _make_cpu_key (struct cpu_key * key, int version, __u32 dirid, __u32 objectid, 
 			   loff_t offset, int type, int length)
 {
   key->version = version;
@@ -923,6 +923,17 @@ static void init_inode (struct inode * i
 	    inode->i_generation = INODE_PKEY (inode)->k_dir_id;
 	else
 	    inode->i_generation = le32_to_cpu( sd->u.sd_generation );
+#ifdef CONFIG_REISERFS_RAW
+        if (ih->ih_item_len == RAW_SD_SIZE) {
+            inode->u.reiserfs_i.lastref = le32_to_cpu (ATTR_LASTREF (sd));
+            inode->u.reiserfs_i.expires = le32_to_cpu (ATTR_EXPIRES (sd));
+            inode->u.reiserfs_i.user1   = le32_to_cpu (ATTR_USER1 (sd));
+        }
+        else {
+            /* make raw/non-raw inodes clearly distinguishable */
+            inode->u.reiserfs_i.lastref = 0;
+        }
+#endif
     }
 
     /* nopack = 0, by default */
@@ -947,7 +958,7 @@ static void init_inode (struct inode * i
 
 
 // update new stat data with inode fields
-static void inode2sd (void * sd, struct inode * inode)
+void inode2sd (void * sd, struct inode * inode)
 {
     struct stat_data * sd_v2 = (struct stat_data *)sd;
 
@@ -1010,7 +1021,15 @@ static void update_stat_data (struct pat
 	// path points to old stat data
 	inode2sd_v1 (B_I_PITEM (bh, ih), inode);
     } else {
-	inode2sd (B_I_PITEM (bh, ih), inode);
+        struct stat_data *sd = (struct stat_data *)B_I_PITEM (bh, ih);
+        inode2sd (sd, inode);
+#ifdef CONFIG_REISERFS_RAW
+        if (ih->ih_item_len == RAW_SD_SIZE) {
+            ATTR_LASTREF(sd) = cpu_to_le32 (inode->u.reiserfs_i.lastref);
+            ATTR_EXPIRES(sd) = cpu_to_le32 (inode->u.reiserfs_i.expires);
+            ATTR_USER1(sd)   = cpu_to_le32 (inode->u.reiserfs_i.user1);
+        }
+#endif
     }
 
     return;
@@ -1131,21 +1150,61 @@ void reiserfs_read_inode2 (struct inode 
 }
 
 
+/*
+ * For fs mounted in raw mode, we want 64bit inode numbers (in raw
+ * mode they serve as filenames, and we want to minimize collision
+ * probability).  Hence the need for find_actor.  For non-raw fs it
+ * is not used, so no harm to efficiency.
+ */
+static int
+reiserfs_find_actor(struct inode *inode, unsigned long ino, void *opaque)
+{
+    struct reiserfs_iget4_args *args = opaque;
+    __u32 dir_id = args->objectid;
+
+    return (dir_id == INODE_PKEY(inode)->k_dir_id);
+}
+
 struct inode * reiserfs_iget (struct super_block * s, struct cpu_key * key)
 {
     struct inode * inode;
     struct reiserfs_iget4_args args ;
+    find_inode_t find_actor = reiserfs_raw(s)? reiserfs_find_actor : NULL;
 
     args.objectid = key->on_disk_key.k_dir_id ;
+    inode = iget4 (s, key->on_disk_key.k_objectid, find_actor, &args);
+#if 0
     inode = iget4 (s, key->on_disk_key.k_objectid, 0, (void *)(&args));
     if (!inode) 
       return inode ;
-
+    
     if (comp_short_keys (INODE_PKEY (inode), key) || is_bad_inode (inode)) {
-	/* either due to i/o error or a stale NFS handle */
-	iput (inode);
-	inode = 0;
+      /* either due to i/o error or a stale NFS handle */
+      iput (inode);
+      inode = 0;
     }
+#endif
+    if (inode && is_bad_inode (inode)) {
+        if (reiserfs_raw (inode->i_sb)) 
+            /* In RAW mode, query for nonexistent inode is part of
+               normal operation -- just like attempts to open
+               nonexistent file in normal mode.  If we iput() the
+               resulting bad inode as is, the inode will stay in
+               i-cache, which results in cluttering i-cache with bad
+               inodes.  To avoid that, we drop i_nlink so iput can
+               destroy the inode at once */
+            inode->i_nlink = 0;
+        else
+          /* In normal mode, bad inodes are rare exception */
+            reiserfs_warning ("vs-13048: reiserfs_iget: "
+                              "bad_inode. Stat data of (%lu %lu) not found\n",
+                              key->on_disk_key.k_dir_id, key->on_disk_key.k_objectid);
+        iput (inode);
+        inode = 0;
+    }
+    if (! inode)
+        inode = ERR_PTR (-ENOENT);
+    
     return inode;
 }
 
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/ioctl.c linux/fs/reiserfs/ioctl.c
--- /usr/src/linux-2.4.9/fs/reiserfs/ioctl.c	Thu Mar 22 06:28:56 2001
+++ linux/fs/reiserfs/ioctl.c	Sat Aug 25 20:21:43 2001
@@ -27,14 +27,73 @@
 int reiserfs_ioctl (struct inode * inode, struct file * filp, unsigned int cmd,
 		unsigned long arg)
 {
+    struct reiserfs_raw_ioctl_arg ra;
+    struct reiserfs_raw_ioctl_arg *user_ra = (struct reiserfs_raw_ioctl_arg *)arg;
+
 	switch (cmd) {
 	    case REISERFS_IOC_UNPACK:
 		if (arg)
 		    return reiserfs_unpack (inode, filp);
-			
+                return -ENOTTY;
+
+#ifdef CONFIG_REISERFS_RAW
+            case REISERFS_IOC_RAWSETATTR:
+                if (copy_from_user (&ra, user_ra, sizeof ra))
+                    return -EFAULT;
+                return reiserfs_rawsetattr_f (inode, &ra);
+#endif /* CONFIG_REISERFS_RAW */
+            
 	    default:
 		return -ENOTTY;
 	}
+}
+
+int reiserfs_dir_ioctl (struct inode * inode, struct file * filp, unsigned int cmd,
+                        unsigned long arg)
+{
+    struct reiserfs_raw_ioctl_arg ra;
+    struct reiserfs_raw_ioctl_arg *user_ra = (struct reiserfs_raw_ioctl_arg *)arg;
+    int r;
+
+    switch (cmd) {
+#ifdef CONFIG_REISERFS_RAW
+    case REISERFS_IOC_RAWOPEN:
+        if (copy_from_user (&ra, user_ra, sizeof ra))
+            return -EFAULT;
+        if ((r = reiserfs_rawopen (inode, filp->f_vfsmnt, &ra)) < 0)
+            return r;
+        if (copy_to_user (user_ra, &ra, sizeof ra))
+            return -EFAULT;
+        return r;               /* fd */
+
+    case REISERFS_IOC_RAWCREAT:
+        if (copy_from_user (&ra, user_ra, sizeof ra))
+            return -EFAULT;
+        return reiserfs_rawcreat (inode, filp->f_vfsmnt, &ra);
+
+    case REISERFS_IOC_RAWUNLINK:
+        if (copy_from_user (&ra, user_ra, sizeof ra))
+            return -EFAULT;
+        return reiserfs_rawunlink (inode, &ra);
+
+    case REISERFS_IOC_RAWSETATTR:
+        if (copy_from_user (&ra, user_ra, sizeof ra))
+            return -EFAULT;
+        return reiserfs_rawsetattr (inode, &ra);
+    case REISERFS_IOC_TIMEDWAIT:
+          {
+                struct reiserfs_sigtimedwait_arg sa;
+                if( copy_from_user
+                        ( &sa, 
+                          ( struct reiserfs_sigtimedwait_arg * ) arg, sizeof sa ) )
+                  return -EFAULT;
+                return reiserfs_sigtimedwait( inode, &sa );
+          }
+#endif /* CONFIG_REISERFS_RAW */
+
+    default:
+        return -EINVAL;
+    }
 }
 
 /*
diff -rupN /usr/src/linux-2.4.9/fs/reiserfs/objectid.c linux/fs/reiserfs/objectid.c
--- /usr/src/linux-2.4.9/fs/reiserfs/objectid.c	Sat Apr 28 00:18:08 2001
+++ linux/fs/reiserfs/objectid.c	Sat Aug 25 18:36:21 2001
@@ -170,9 +170,9 @@ void reiserfs_release_objectid (struct r
 	}
 	i += 2;
     }
-
-    reiserfs_warning ("vs-15010: reiserfs_release_objectid: tried to free free object id (%lu)", 
-		      objectid_to_release);
+    if (! reiserfs_raw (s))
+        reiserfs_warning ("vs-15010: reiserfs_release_objectid: tried to free free object id (%lu)", 
+                          objectid_to_release);
 }
 
 
